<?php
/****************************************************************************
*    Copyright (C) 1999 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************/ 

// EDIT
require("/home/httpd/phpshop/etc/phpshop.cfg");

// OPTIONAL
// If using PHPLIB without access to php3.ini
//$_PHPLIB["libdir"]="/home/groups/phpshop/phplib-7.2/";
//require("/home/groups/phpshop/phplib-7.2/prepend.php3");


// NO EDIT
require(DOCROOT . "etc/ps_local.inc");
require(LIBROOT . "ps_main.inc");
require(LIBROOT . "ps_product.inc");
require(LIBROOT . "ps_product_attribute.inc");
require(LIBROOT . "ps_product_category.inc");
require(LIBROOT . "ps_product_price.inc");
require(LIBROOT . "ps_vendor.inc");
require(LIBROOT . "ps_vendor_category.inc");
require(LIBROOT . "ps_user.inc");
require(LIBROOT . "ps_user_address.inc");
require(LIBROOT . "ps_order.inc");
require(LIBROOT . "ps_order_process.inc");
require(LIBROOT . "ps_function_reg.inc");
require(LIBROOT . "ps_directory_reg.inc");
require(LIBROOT . "ps_vship_method.inc");
require(LIBROOT . "ps_shopper.inc");
require(LIBROOT . "ps_shopper_group.inc");
require(LIBROOT . "ps_cart.inc");


// Instantiate base classes
$db = new ps_DB;
$ps_user = new ps_user;
$ps_user_address = new ps_user_address;
$ps_vendor = new ps_vendor;
$ps_vendor_category = new ps_vendor_category;
$ps_product = new ps_product;
$ps_order_process = new ps_order_process;
$ps_order = new ps_order;
$ps_product_attribute = new ps_product_attribute;
$ps_product_category = new ps_product_category;
$ps_product_price = new ps_product_price;
$ps_function_reg= new ps_function_reg;
$ps_shopper= new ps_shopper;
$ps_shopper_group= new ps_shopper_group;
$ps_directory_reg= new ps_directory_reg;
$ps_vship_method= new ps_vship_method;

// Open page sesion, authentication, permission and user
page_open(array("sess"=>"ps_Session",
		"auth"=>"ps_Challenge_Crypt_Auth",
		"perm"=>"ps_Perm",
		"user"=>"ps_User"
		));

// Set ps_vendor_id is this user is nobody
if ($auth->auth["uid"] == "nobody") {
  $q = "SELECT vendor_id FROM vendor";
  $db->query($q);
  if ($db->next_record()) {
     $ps_vendor_id=$db->f("vendor_id");
     $sess->register("ps_vendor_id");
  }
}


// Register some session variables that we use later
if (!isset($last_page)) {
  $sess->register("last_page");
}
if (!isset($form_key)) {
  $sess->register("form_key");
}
if (!isset($vars)) {
  $sess->register("vars");
}
if (!isset($ps_cart)) {
  $ps_cart = new ps_cart;
  $ps_cart->idx = 0;
  $sess->register("ps_cart");
}


// Only register $return_to_page if it is not registered already.
// It can be empty at times and in fact usually will be
if (!$sess->is_registered($return_to_page)) {
   $sess->register("return_to_page");
}

// Generate a form_key to see if this page is being re-submitted.  
if ($HTTP_POST_VARS) {
   while (list($key, $value) = each($HTTP_POST_VARS)) {
     if(!ereg("_image$",$key)) {
       $new_form_key .= "$key$value"; 
     }
   }
   reset($HTTP_POST_VARS);
}
elseif ($HTTP_GET_VARS) {
  while (list($key, $value) = each($HTTP_GET_VARS)) {
    $new_form_key .= "$key$value"; 
  }
   reset($HTTP_GET_VARS);
}

// Set cache for specific pages
// Check for cache variable
if ($cache) {
  $sess->allowcache = "public";
  $sess->put_headers();
}

/* Center of it all
** Get permission on func and page
** Check for form re-submission
** Process func
** Check for error
** Process page
** Check for error
** Display page
*/

// Get Function Permissions
// Sets $func_perms
if ($func) {
  $q = "SELECT * from function where function_name='$func'";
  $db->query($q);
  if ($db->next_record()) {
    $func_perms = $db->f("function_perms");
    $func_class = $db->f("function_class");
    $func_method = $db->f("function_method");
  }
  else {
    $error="Function not registered.";
  }
}
// Get Directory Permissions
// Set $dir_perms
if (!$page) {
  $page = HOMEPAGE;
} 
if ($page) {
  $b = dirname("$page.ihtml");
  if ($b == "") $b="/";
  $q = "SELECT * from directory where directory_name='$b/'";
  $db->query($q);
  if ($db->next_record()) {
    $dir_perms = $db->f("directory_perms");
  }
  else {
    $error="Directory not registered.";
  }
}


// Check for repost
// Sets $repost to True if this is being reposted
// Must not that forms submitted using image form fields 
// will not be considered reports and will cause the form to repost.
// This will be fixed ASAP.

// Check for repost
if ($new_form_key != $form_key) {
  // Set $vars since it is not a repost and register it
  if ($HTTP_POST_VARS) {
    $vars = $HTTP_POST_VARS;
    if (!isset($vars)) {
      $sess->register("vars");
    }
  }
  elseif ($HTTP_GET_VARS) {
    $vars = $HTTP_GET_VARS;
    if (!isset($vars)) {
      $sess->register("vars");
    }
  }
  $repost = 0;
}
else {
  $cmd = "blank";
  $repost = 1;
}

// backup last form_key
$form_key = $new_form_key;

// Check permission on function access, if access run method
if ($func_perms) 
if ($perm->check($func_perms)) { 
  // User has permission to run this command
  if (!$repost) {
    $cmd = "\$ok = \$" . $func_class . "->" . $func_method . "(\$vars);";
    eval($cmd);
    if (!$ok) {
      if ($vars["login"] == "1") {
        $error = $vars["error"];
        $login=1;
      }
      else {
       $page = $last_page;
       $error = $vars["error"];
      }
    }
    else {
      $error="";
      $page = $vars["page"];
    }
  }
  else {
    // It is a repost
    $page = $last_page;
  }
}
else {
   $error = "Sorry, you not have enough sufficient rights to run this function.";
}
  

// Check permission on directory access
if ($dir_perms)
if ($perm->check($dir_perms) && !$login) { 
  // Capture page as last_page
  $last_page = $page;
  // Go to default if no page was supplied
  if (!$page) {
    $page = HOMEPAGE;
  }
  // Check for file existence
  if (!file_exists(DOCROOT . "$page.ihtml")) {
    $error =  "Given filename does not exist.<BR>Cannot find file: $page";
    $page = $last_page;
  }
}
else {
  // If this is the first login attempt set the pebble so we can find our way back
  // to the page we intended to visit before the login button was pressed
  if (!$pebble && !$login) {
    $last_page=$page;
    $pebble=1;
  }
  $page=LOGINPAGE;
}

// Check for file existence
if (!file_exists(DOCROOT . "$page.ihtml")) {
  $error =  "Given filename does not exist.<BR>Cannot find file: $page";
  $page = $last_page;
}                      

// Load up document.
include(DOCROOT . "$page.ihtml");


// Set debug option on/off
if (DEBUG) {
  require(LIBROOT . "debug.ihtml");
}      

page_close(); 
?>
