<?php
/*
 * Session Management for PHP3
 *
 * Copyright (c) 1998,1999 SH Online Dienst GmbH
 *                    Boris Erdmann, Kristian Koehntopp
 *
 * $Id: ps_local.inc,v 1.2 2000/02/21 22:36:49 pfmartin Exp $
 *
 */ 

class ps_DB extends DB_Sql {
  var $Host     = "opus";
  var $Database = "phpshop";
  var $User     = "dbuser";
  var $Password = "";

  function f($Name) {
    return stripslashes($this->Record[$Name]);
  }

  /* Selective field */
  function sf($Name) {
    global $vars;
    if ($vars["error"] and $vars["$Name"]) {
      return stripslashes($vars["$Name"]);
    } else {
      return stripslashes($this->Record[$Name]);
    }
  }                             

  function p($Name) {
      print stripslashes($this->Record[$Name]);
  }                             

  /* Selective print */
  function sp($Name) {
    global $vars;
    if ($vars["error"] and $vars["$Name"]) {
      print stripslashes($vars["$Name"]);
    } else {
      print stripslashes($this->Record[$Name]);
    }
  }                             
 
}

class ps_CT_Sql extends CT_Sql {
  var $database_class = "ps_DB";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.
}

#class ps_CT_Split_Sql extends CT_Split_Sql {
#  var $database_class = "ps_DB";         ## Which database to connect...
#  var $database_table = "active_sessions_split"; ## and find our session data in this table.
#  var $split_length = 4096                    ## Split rows every 4096 bytes
#}

#class ps_CT_Shm extends CT_Shm {
#  var $max_sessions   = 500;               ## number of maximum sessions
#  var $shm_key        = 0x123754;          ## unique shm identifier
#  var $shm_size       = 64000;             ## size of segment
#}

#class ps_CT_Ldap extends CT_Ldap {
#   var $ldap_host = "localhost";
#   var $ldap_port = 389;
#   var $basedn    = "dc=your-domain, dc=com";
#   var $rootdn    = "cn=root, dc=your-domain, dc=com";
#   var $rootpw    = "secret";
#   var $objclass  = "phplibdata";
#}

#class ps_CT_Dbm extends CT_DBM {
#   var $dbm_file  = "must_exist.dbm";
#}

class ps_Session extends Session {
  var $classname = "ps_Session";

  var $cookiename     = "";                ## defaults to classname
  var $magic          = "JepiBlo";         ## ID seed
  var $mode           = "cookie";          ## We propagate session IDs with cookies
  var $fallback_mode  = "get";
  var $lifetime       = 0;                 ## 0 = do session cookies, else minutes
  var $that_class     = "ps_CT_Sql";  ## name of data storage container
  var $gc_probability = 5;  
  var $allowcache = "no";

}

class ps_User extends User {
  var $classname = "ps_User";

  var $magic          = "AbbaGold";     ## ID seed
  var $that_class     = "ps_CT_Sql"; ## data storage container
}

##
## ps_Challenge_Crypt_Auth: Keep passwords in md5 hashes rather 
##                           than cleartext in database
## Author: Jim Zajkowski <jim@jimz.com>

class ps_Challenge_Crypt_Auth extends Auth {
  var $classname      = "ps_Challenge_Crypt_Auth";

  var $lifetime       =  0;

  var $magic          = "Frobozzica";  ## Challenge seed
  var $database_class = "ps_DB";
  var $database_table = "auth_user_md5";
  var $nobody = true;
  var $cancel_login = "cancel_x";


  function auth_loginform() {
    global $sess;
    global $auth;
    global $perm;
    global $challenge;
    global $page;
    global $last_page;
    global $return_to_page;
   
    if(!$return_to_page) {
       $return_to_page = $last_page;
    }
 
    $challenge = md5(uniqid($this->magic));
    $sess->register("challenge");
    
    include("/home/groups/phpshop/phpshop0.1/status/crcloginform.ihtml");
  }
  
  function auth_validatelogin() {

    global $username, $password, $challenge, $response, $ps_vendor_id, $ps_vendor, $sess, $return_to_page;

    $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    
    $this->db->query(sprintf("select user_id,perms,password ".
                "from %s where username = '%s'",
                          $this->database_table,
                          addslashes($username)));

    while($this->db->next_record()) {
      $uid   = $this->db->f("user_id");
      $perm  = $this->db->f("perms");
      $pass  = $this->db->f("password");   ## Password is stored as a md5 hash
    }
    $exspected_response = md5("$username:$pass:$challenge");

    // For single store functionality.  Will set user to vendor_id upon login
    if ($perm == "shopper")
      $q = "SELECT vendor_id FROM shopper_vendor_xref WHERE user_id='$uid'";
    else
      $q = "SELECT vendor_id FROM auth_user_vendor WHERE user_id='$uid'";
    $this->db->query($q);

    if ($this->db->next_record()) {
       $ps_vendor_id=$this->db->f("vendor_id");
       $sess->register("ps_vendor_id");
    }

    ## True when JS is disabled
    if ($response == "") {
      if (md5($password) != $pass) {       ## md5 hash for non-JavaScript browsers
        return false;
      } else {
        $this->auth["perm"] = $perm;
        /* gday */
        $return_to_page = "";
        return $uid;
      }
    }
    
    ## Response is set, JS is enabled
    if ($exspected_response != $response) {
      return false;
    } else {
      $this->auth["perm"] = $perm;
      /* gday */
      $return_to_page = "";
      return $uid;
    }
  }
}

class ps_Perm extends Perm {

  var $classname = "ps_Perm";
 
  var $permissions = array(
                            "anonymous"  => 1,
                            "shopper"    => 2,
                            "storeadmin" => 4,
  			    "demo" 	 => 8,
                            "admin"      => 16
                          );

    
  function check($perm) {
    // $perm can be comma separated list of permissions
    global $auth;
    $db = new ps_DB;

    // Parse all permissions in argument, comma separated
    // It is assumed auth_user only has one group per user.
    $p1 = explode(",", $auth->auth["perm"]);
    if ($perm == "none") {
      $p2 = $p1;
    }
    else {
      $p2 = explode(",", $perm);
    }
    while (list($key1, $value1) = each($p1)) {
      while (list($key2, $value2) = each($p2)) {
	if ($value1 == $value2) {
	  return True;
	}
      }
    }
    return False;
  }
 
  function perm_invalid($does_have, $must_have) {
    global $perm, $auth, $sess;
    global $_PHPLIB;
    
    include($_PHPLIB["libdir"] . "perminvalid.ihtml");
  }
}

?>
