<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************/ 

class ps_directory_reg {
  var $classname = "ps_directory_reg";
  var $error;
  
  /*
  ** VALIDATION FUNCTIONS
  **
  */

  function validate_add($d) {
    
    $db = new ps_DB;
    
    if (!$d["directory_name"]) {
      $this->error = "ERROR:  You must enter a name for the directory.";
      return False;	
    }
    if ($d["directory_name"]) {
      $q = "SELECT count(*) as rowcnt from directory where directory_name='" .  $d["directory_name"] . "'";
      $db->query($q);
      $db->next_record();
      if ($db->f("rowcnt") > 0) {
	$this->error = "The given directory name already exists.";
	return False;
      }      
    }
    if (!$d["directory_perms"]) {
      $this->error = "ERROR:  You must enter permissions for the directory.";
      return False;	
    }
    return True;    
  }
  
  function validate_delete($d) {
    
    if (!$d["directory_id"]) {
      $this->error = "ERROR:  Please select a directory to delete.";
      return False;
    }
    else {
      return True;
    }
  }
  
  function validate_update($d) {
    
    if (!$d["directory_name"]) {
      $this->error = "ERROR:  You must enter a name for the directory.";
      return False;	
    }
    if (!$d["directory_perms"]) {
      $this->error = "ERROR:  You must enter permissions for the directory.";
      return False;	
    }
    else {
      return True;
    }
  }
  
  
  /**************************************************************************
   * name: add()
   * created by: pablo
   * description: creates a new function record
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    $hash_secret="PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if (!$this->validate_add($d)) {
      $d["error"] = $this->error;
      return False;
    }
    $q = "INSERT INTO directory (directory_name, directory_description, directory_perms) ";
    $q .= " VALUES ('";
    $q .= $d["directory_name"] . "','";
    $q .= $d["directory_description"] . "','";
    $q .= $d["directory_perms"] . "')";
    $db->query($q);
    $db->next_record();
    return True;

  }
  
  /**************************************************************************
   * name: update()
   * created by: pablo
   * description: updates function information
   * parameters:
   * returns:
   **************************************************************************/
  function update(&$d) {
    $db = new ps_DB;
    $timestamp = time();

    if (!$this->validate_update($d)) {
      $d["error"] = $this->error;
      return False;	
    }
    $q = "UPDATE directory set ";
    $q .= "directory_name='" . $d["directory_name"];
    $q .= "',directory_perms='" . $d["directory_perms"];
    $q .= "', directory_description='" . $d["directory_description"];
    $q .= "' WHERE directory_id='" . $d["directory_id"] . "'";
    $db->query($q);
    $db->next_record();
    return True;
  }

  /**************************************************************************
   * name: delete()
   * created by: pablo
   * description: Should delete a category and and categories under it.
   * parameters: 
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if (!$this->validate_delete($d)) {
      $d["error"]=$this->error;
      return False;
    }
    $q = "DELETE from directory where directory_id='" . $d["directory_id"] . "'";
    $db->query($q);
    $db->next_record();
    return True;
  }


  /**************************************************************************
   * name: find()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function find($d, $start=0) {
    $db = new ps_DB;
    

    $q = "SELECT * from auth_user_md5,user_info where ";
    $q .= "auth_user_md5.username LIKE '%" . $d["username"] . "%' AND ";
    $q .= "user_info.customer_no LIKE '%" . $d["customer_no"] . "%' AND ";
    $q .= "user_info.name LIKE '%" . $d["customer_name"] . "%' AND ";
    $q .= "user_info.address1 LIKE '%" . $d["address_1"] . "%' AND ";
    $q .= "user_info.address2 LIKE '%" . $d["address_2"] . "%' AND ";
    $q .= "user_info.city LIKE '%" . $d["city"] . "%' AND ";
    $q .= "user_info.state LIKE '%" . $d["state"] . "%' AND ";
    $q .= "user_info.zipcode LIKE '%" . $d["zipcode"] . "%' AND ";
    $q .= "user_info.country LIKE '%" . $d["country"] . "%' AND ";
    $q .= "user_info.dayphone LIKE '%" . $d["dayphone"] . "%' AND ";
    $q .= "user_info.evephone LIKE '%" . $d["evephone"] . "%' AND ";
    $q .= "auth_user_md5.user_id = user_info.user_id";
    $db->query($q);
    $db->next_record();
    if ($db->nf() == 1) {
      return "?id=" . $db->f("user_id");
    }
    $t = new phpshop_Table;
    $t->query = $q;
    $t->start=$start;
    // Select fields to display
    $t->fields = array(
		       "username",
		       "name",
		       "address1",
		       "city",
		       "dayphone"
		       );
    
    // Set column header names
    $t->map_cols = array(
			 "username" => "UserName",
			 "name" => "Full Name",
			 "address1"=>"Address",
			 "city"=>"City",
			 "dayphone"=>"Phone"
			 );
    $t->show_table();
    return True;
  }

  /**************************************************************************
   * name: find()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function list_groups($name,$group_group) {
    global $perm;
    $db = new ps_DB;

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
    while (list($key,$value) = each($perm->permissions)) {
      if ($key == $group_name) {
	echo "<OPTION VALUE=$key SELECTED>$key</OPTION>\n";
      }
      else {
	echo "<OPTION VALUE=$key>$key</OPTION>\n";
      }
    }
    echo "</SELECT>\n";
  }        


  /**************************************************************************
   * name: traverse_tree_down()
   * created by:
   * description:
  ** This function goes through the category table and establishes the category
  ** tree based on the parent-child relationships defnied in the category_xref table
  ** This is VERY recursive...
  **
   * parameters:
   * returns:
   **************************************************************************/
  function traverse_tree_down($category_id=0, $cnt=0) {
  global $sess;
    $db = new ps_DB;
    $level=0;
    
    $cnt++;

    $q = "SELECT * from category,category_xref ";
    $q .= "WHERE category_xref.category_parent_id='";
    $q .= $category_id . "' AND ";
    $q .= "category.category_id=category_xref.category_child_id";
    $db->query($q);

    while ($db->next_record()) {
      $level++;
      for ($i=0;$i<$cnt;$i++) {
        echo "&nbsp;&nbsp;&nbsp;";
      }
      echo "&#095;&#095&#095;&#095;&#095&#095;|$cnt|&nbsp;";
      $url  = SECUREURL . "?page=showProductCategory&category_id=";
      $url .= $db->f("category_child_id") . "&category_parent_id=";
      $url .= $db->f("category_parent_id");
      echo "<A HREF=" . $sess->url($url) . ">";
      echo $db->f("category_name") . "</A>:";
      echo "&nbsp;&nbsp;" . $db->f("category_description");
      echo "<BR>";              
      $this->traverse_tree_down($db->f("category_child_id"), $cnt);
    }    
  }
  



  /**************************************************************************
  ** name: traverse_tree_up()
  ** created by:
  ** description: This function goes through the category table and establishes
  **              the category tree based on the parent-child relationships 
  **              defnied in the category_xref table
  ** This is VERY recursive...
   * parameters:
   * returns:
   **************************************************************************/
  function traverse_tree_up($category_id, $cnt=0) {
    $db = new ps_DB;
    $level=0;
    
    $cnt++;
    $q = "SELECT * from category, category_xref ";
    $q .= "WHERE category_xref.category_child_id=' ";
    $q .= "$category_id' AND ";
    $q .= "category.category_id=category_xref.category_parent_id";
    $db->query($q);
    while ($db->next_record()) {
      $level++;
      if ($cnt == 1) {
	echo "<OPTION SELECTED VALUE=" . $db->f("category_child_id");
      }
      else {
	echo "<OPTION VALUE=" . $db->f("category_child_id");
      }
      echo ">" . $db->f("category_name") . "</OPTION>";

      $this->traverse_tree_up($db->f("category_parent_id"), $cnt);
    }    
  }



  /**************************************************************************
  ** name: list_parents()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_parents($category_id) {
    $db = new ps_DB;

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
    $this->traverse_tree_up($category_id);
    echo "</SELECT>\n";    
  }
  


  /**************************************************************************
  ** name: list_all()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_all($name, $category_id) {

    $db = new ps_DB;

    $q = "SELECT * from category_xref where category_child_id='$category_id'";
    $db->query($q);
    $db->next_record();
    $category_id=$db->f("category_parent_id");

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Default-Top Level</OPTION>\n";
    $this->list_tree($category_id);
    echo "</SELECT>\n";
  }
  

  /**************************************************************************
  ** name: list_tree()
  ** created by:
  ** description: Creates OPTIONS fields for a select
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_tree($category_id, $cid=0, $cnt=0) {
    $db = new ps_DB;
    $level=0;
    
    $cnt++;

    $q = "SELECT * from category,category_xref ";
    $q .= "WHERE category_xref.category_parent_id='";
    $q .= $cid . "' AND ";
    $q .= "category.category_id=category_xref.category_child_id";
    $db->query($q);

    while ($db->next_record()) {
      $level++;
      if ($db->f("category_child_id") != $cid) {
	if ($db->f("category_child_id") == $category_id) {
	  echo "<OPTION SELECTED VALUE=" . $db->f("category_child_id") . ">";
	}
	else {
	  echo "<OPTION VALUE=" . $db->f("category_child_id") . ">";
	}
      }
      for ($i=0;$i<$cnt;$i++) {
        echo "&#151";
      }
      echo "|$cnt|";
      echo "&nbsp;" . $db->f("category_name") . "</OPTION>";
      $this->list_tree($category_id, $db->f("category_child_id"), $cnt);
    }    
  }
}


?>
