<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*
* CLASS DESCRIPTION
*                   
* ps_order
*
* The class handles orders from an adminstrative perspective.  Order
* processing is handled in the ps_process_order.
* 
* propeties:  
* 	
*       error - the error message returned by validation if any
* methods:
*       validate_add()
*	validate_delete()
*	validate_update()
*       add()
*       update()
*       delete()
*	
*
*************************************************************************/
class ps_order {
  var $classname = "ps_order";
  var $error;
  

  /**************************************************************************
   * name: find
   * created by: pablo
   * description: find an order by its order_id
   * parameters:
   * returns:
   **************************************************************************/
  function find(&$d, $start=0) {
    $db = new ps_DB;
    

    $q = "SELECT * from orders where ";
    $q .= "order_id = '" . $d["order_id"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      return True;
    }
    else {
      $d["error"] = "ORDER NOT FOUND:  The order number you entered was not found.";
      return False;
    }
  }


   /**************************************************************************
   * name: order_status_update
   * created by: pablo
   * description: changes the status of an order.  Can be 3 statuses:
   *              default: P - pending
   *                       C - complete
   *                       X - canceled
   * parameters:
   * returns:
   **************************************************************************/
  function order_status_update(&$d) {
    $db = new ps_DB;
 
    $q = "UPDATE orders SET order_status='" . $d["order_status"] . "' ";
    $q .= "WHERE order_id='" . $d["order_id"] . "'";
    $db->query($q);
    $db->next_record();
    $d["order_status"] = "P";

    return True;

  }

   /**************************************************************************
   * name: list_order
   * created by: pablo
   * description: shows a listbox of orders which can be used in a form
   * parameters: set to order_id
   * returns:
   **************************************************************************/
  function list_order($order_status) {
    global $ps_vendor_id;
    $db = new ps_DB;

    $q = "SELECT * FROM orders ";
    $q .= "WHERE vendor_id='$ps_vendor_id' ";
    $q .= "AND order_status='$order_status' order by cdate desc";
    $db->query($q);
    echo "<SELECT NAME=order_id SIZE=" . MAX_ROWS . ">";;
    while ($db->next_record()) {
      echo "<option value=" . $db->f("order_id") . ">";
      printf("%08d", $db->f("order_id"));
      echo "&nbsp;&nbsp;&nbsp;&nbsp;";
      echo date("dMY.H:i", $db->f("cdate"));
      echo "&nbsp;&nbsp;";
      echo $db->f("order_subtotal") . "&nbsp; &nbsp;";
      echo "</OPTION>";
    }
    echo "</SELECT>\n";    
  }
  
}
?>
